package si.ijs.urbanite.simserver.counts;

import com.opencsv.CSVReader;

import java.io.*;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.HashMap;
import java.util.Map;


public class readCountsAmsterdam {
    public static void filterCounts(String dataPath, String city) throws IOException {
        Path amst_counts = Paths.get(dataPath,city,"before_simulation","MCT_NL_Amsterdam_20200101_20220531_23062022105506.csv");
        String line="";
        BufferedReader bf = new BufferedReader(new FileReader(amst_counts.toString()));
        FileWriter fw = new FileWriter(Paths.get(dataPath,city,"before_simulation","counts.csv").toString());
        fw.write("date,location,plus direction,minus direction,lat,long,direction\n");
        while ((line= bf.readLine())!=null){
            String[] l = line.split(";");
            if (l[0].matches("(.*)06.05.2021(.*)")){
                String hour = l[0].split(" ")[1].split(":")[0];
                String lat = l[4].replace(',','.');
                String lon = l[5].replace(',','.');
                fw.write(hour+","+l[1]+","+l[2]+","+l[3]+","+lat+","+lon+","+l[9]+"\n");

            }
            else if (l[0].matches("(.*)07.05.2021(.*)")){
                break;
            }
        }
        fw.close();
        bf.close();
    }
    public static void aggregateRows(Path file) throws IOException {
        Map<String, Integer> rowMap = new HashMap<>();
        BufferedReader bf = new BufferedReader(new FileReader(file.toString()));
        String line="";
        while((line= bf.readLine())!=null){
            String key = line;
            Integer value = rowMap.get(key);
            if (value == null)
                value = 0;
            rowMap.put(key, value + 1);
        }
        bf.close();
//        System.out.println(rowMap.values().stream().mapToInt(a->a).sum());
    }

    public static void main(String[] args) throws IOException {
        Path path = Paths.get("data","amsterdam","before_simulation","counts.csv");
        aggregateRows(path);
//        filterCounts("data","amsterdam");
    }
}
