package si.ijs.urbanite.simserver.entities;

import javax.persistence.Embeddable;

@Embeddable
public class Bounds {
    private Double east;
    private Double west;
    private Double north;
    private Double south;

    Bounds(Double west, Double south, Double east, Double north) {
        this.west = west;
        this.south = south;
        this.east = east;
        this.north = north;
    }

    public Bounds() { }

    public static Bounds from(Double west, Double south, Double east, Double north) {
        return new Bounds(west, south, east, north);
    }

    public static Bounds fromArray(Double[] coords){
        if(coords.length != 4) throw new IllegalArgumentException("Length of bounds array must be 4");
        return new Bounds(coords[0], coords[1], coords[2], coords[3]);
    }

    public Double[] toArray(){
        return new Double[] {west, south, east, north};
    }

    public Double getEast() {
        return east;
    }

    public Double getWest() {
        return west;
    }

    public Double getNorth() {
        return north;
    }

    public Double getSouth() {
        return south;
    }

    public void setEast(Double east) {
        this.east = east;
    }

    public void setWest(Double west) {
        this.west = west;
    }

    public void setNorth(Double north) {
        this.north = north;
    }

    public void setSouth(Double south) {
        this.south = south;
    }
}
