package si.ijs.urbanite.simserver.entities;

import com.fasterxml.jackson.annotation.JsonIgnore;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.*;

@Entity
public class City {

    @Id
    private String cityId;
    private String displayName;
    private Double lat;
    private Double lon;

    @JsonIgnore
    @OneToMany(mappedBy = "city")
    private List<Network> networks;

    @JsonIgnore
    @OneToMany(mappedBy = "city")
    private List<Simulation> simulations;

    public City(String cityId, String displayName, Coordinates coordinates) {
        this.cityId = cityId;
        this.displayName = displayName;
        this.lat = coordinates.getLat();
        this.lon = coordinates.getLon();
        this.networks = new ArrayList<>();
        this.simulations = new ArrayList<>();
    }

    public City() {
    }

    public Coordinates getCoordinates() {
        return new Coordinates(this.lat, this.lon);
    }

    public String getCityId() {
        return cityId;
    }

    public void setCityId(String cityId) {
        this.cityId = cityId;
    }

    public String getDisplayName() {
        return displayName;
    }

    public void setDisplayName(String displayName) {
        this.displayName = displayName;
    }

    public Double getLat() {
        return lat;
    }

    public void setLat(Double lat) {
        this.lat = lat;
    }

    public Double getLon() {
        return lon;
    }

    public void setLon(Double lon) {
        this.lon = lon;
    }

    public List<Network> getNetworks() {
        return networks;
    }

    public void setNetworks(List<Network> networks) {
        this.networks = networks;
    }

    public List<Simulation> getSimulations() {
        return simulations;
    }

    public void setSimulations(List<Simulation> simulations) {
        this.simulations = simulations;
    }

    @Override
    public String toString() {
        return "City{" +
                "cityId='" + cityId + '\'' +
                ", displayName='" + displayName + '\'' +
                ", coordinates=" + this.lat + ", " + this.lon +
                '}';
    }
}
