package si.ijs.urbanite.simserver.entities;

import javax.persistence.Embeddable;

@Embeddable
public class Coordinates {
    private double lat;
    private double lon;
    Coordinates(Double lat, Double lon) {
        this.lat = lat;
        this.lon = lon;
    }

    public Coordinates() {

    }

    public static Coordinates from(Double lat, Double lon) {
        return new Coordinates(lat, lon);
    }

    public static Coordinates fromArray(Double[] coords){
        if(coords.length != 2) throw new IllegalArgumentException("Length of coordinates array must be 2");
        return new Coordinates(coords[0], coords[1]);
    }

    public Double[] toArray(){
        return new Double[] {lat, lon};
    }

    public Double getLat() {
        return lat;
    }

    public void setLat(Double lat) {
        this.lat = lat;
    }

    public Double getLon() {
        return lon;
    }

    public void setLon(Double lon) {
        this.lon = lon;
    }

    @Override
    public String toString() {
        return "{" +
                "lat:" + lat +
                ", lon:" + lon +
                '}';
    }
}
