package si.ijs.urbanite.simserver.entities;

import javax.persistence.*;
import java.util.ArrayList;
import java.util.List;

@Entity
public class Plan {
    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE,
            generator = "plan_id_gen")
    @SequenceGenerator(name = "plan_id_gen",
            sequenceName = "plan_id_seq", allocationSize = 1)
    private int id;
    private String name;

    @ManyToOne
    @JoinColumn(name = "network")
    private Network network;

    @OneToMany(mappedBy = "plan")
    private List<Simulation> simulations;

    public Plan() {}

    public Plan(String name, Network network) {
        this.name = name;
        this.network = network;
        this.simulations = new ArrayList<Simulation>();
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Network getNetwork() {
        return network;
    }

    public void setNetwork(Network network) {
        this.network = network;
    }

    public List<Simulation> getSimulations() {
        return simulations;
    }

    public void setSimulations(List<Simulation> simulations) {
        this.simulations = simulations;
    }
}
