package si.ijs.urbanite.simserver.network;

import org.matsim.api.core.v01.Id;
import org.matsim.api.core.v01.Scenario;
import org.matsim.api.core.v01.network.Link;
import org.matsim.api.core.v01.network.Network;
import org.matsim.api.core.v01.network.NetworkWriter;
import org.matsim.api.core.v01.network.Node;
import org.matsim.core.config.Config;
import org.matsim.core.config.ConfigUtils;
import org.matsim.core.network.NetworkUtils;
import org.matsim.core.scenario.ScenarioUtils;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;

public class AddNetowrkLayer {
    public static Network addLayer(Network network){

        for (Id<Link> l : network.getLinks().keySet()){

            if (network.getLinks().get(l).getAttributes().size() >0) {
                try {
                    String name = network.getLinks().get(l).getAttributes().getAttribute("osm:way:name").toString();
                    if (name.matches("(.*)Moyua(.*)")){
                       Node from_node = network.getLinks().get(l).getFromNode();
                       Node to_node = network.getLinks().get(l).getToNode();
                       Double lenght = network.getLinks().get(l).getLength();
                       Double freespeed = network.getLinks().get(l).getFreespeed();
                       Double capacity  = network.getLinks().get(l).getCapacity();
                       Double numLanes = network.getLinks().get(l).getNumberOfLanes();


                       //create new link
                        Id<Link> l_id =  Id.createLinkId(String.valueOf(network.getLinks().get(l).getId()+"_pt"));
                        Link link = NetworkUtils.createAndAddLink(network,l_id, from_node,to_node,lenght,freespeed,capacity,numLanes);

                        network.getLinks().get(link.getId()).setAllowedModes(new HashSet<String>(Collections.singleton("car")));

//                        NetworkWriter writer = new NetworkWriter(network);
//                        writer.write(Paths.get("Scenarios","Bilbao","ClosedMoyua","input","network1.xml").toString());
                    }
                } catch (Exception e) {
//                    e.printStackTrace();
                }

            }}
        return network;

    }
    public static ArrayList<String> getMoyuaLinks(Network network){
        ArrayList<String> links = new ArrayList<>();

        for (Id<Link> l : network.getLinks().keySet()){

            if (network.getLinks().get(l).getAttributes().size() >0) {
                try {
                    String name = network.getLinks().get(l).getAttributes().getAttribute("osm:way:name").toString();
                    if (name.matches("(.*)Moyua(.*)")){
                        links.add(network.getLinks().get(l).getId().toString());

                    }
                } catch (Exception e) {
//                    e.printStackTrace();
                }

            }}
        return links;
    }

    public static void checkMoodOnLink(Network network) throws IOException {
        //read events file and check the mode on it

        BufferedReader bf = new BufferedReader(new FileReader("Scenarios/bilbao/ClosedMoyua/output/output_events.xml"));


        String line = "";

        ArrayList<String> links = getMoyuaLinks(network);

        while ((line = bf.readLine()) != null) {
            if (line.matches("(.*)entered link(.*)")) {
                String link = line.split("link=\"")[1].split("\"")[0];
                String vehicle = line.split("vehicle=\"")[1].split("\"")[0];
                if (link.matches("(.*)_pt")&&!vehicle.matches("(.*)pt(.*)")){
                    System.out.println(line);
                }
//                if (links.contains(link)&&!vehicle.matches("(.*)bicycle(.*)")){
//                    System.out.println(line);
//                }
            }
        }
    }

    public static void main(String[] args) throws IOException {
        Config config = ConfigUtils.loadConfig(Paths.get("Scenarios","Bilbao","ClosedMoyua","input","config.xml").toString());
        Scenario sc = ScenarioUtils.loadScenario(config);
//        getMoyuaNodes(sc.getNetwork());
        checkMoodOnLink(sc.getNetwork());
    }
}
