package si.ijs.urbanite.simserver.network;

import org.matsim.api.core.v01.Id;
import org.matsim.api.core.v01.network.Link;
import org.matsim.api.core.v01.network.Network;
import org.matsim.api.core.v01.network.NetworkWriter;
import org.matsim.api.core.v01.network.Node;
import org.matsim.core.network.NetworkUtils;
import org.matsim.core.utils.geometry.CoordUtils;


import java.nio.file.Path;
import java.nio.file.Paths;

public class AddTunnel {
    public static Network addTunnel(Network network, String city_id, String network_id){
        //add two links that connect the port and a motorway
        //link 0000 from node id: 4541346906 to node id: 1519479202
        //link 00000 from node id: 180985933 to node id: 4541346906

        Node fromNode1 = network.getNodes().get("4541346906");
        Node toNode1 = network.getNodes().get("1519479202");

        Node fromNode2 = network.getNodes().get("180985933");
        Node toNode2 = network.getNodes().get("4541346906");

        for (Id<Node> nodeId: network.getNodes().keySet()){
            if (nodeId.toString().equals("4541346906")){
                 fromNode1 = network.getNodes().get(nodeId);
            }
            if (nodeId.toString().equals("1519479202")){
                toNode1 = network.getNodes().get(nodeId);
            }
            if (nodeId.toString().equals("180985933")){
                fromNode2 = network.getNodes().get(nodeId);
            }
            if (nodeId.toString().equals("4541346906")){
                toNode2 = network.getNodes().get(nodeId);
            }
        }

        //create new link
        Id<Link> l_id1 =  Id.createLinkId("0000");
        Id<Link> l_id2 =  Id.createLinkId("0001");

        Link link1 = NetworkUtils.createAndAddLink(network,l_id1, fromNode1,toNode1, CoordUtils.calcEuclideanDistance(fromNode1.getCoord(), toNode1.getCoord()),11,600,2);
        Link link2 = NetworkUtils.createAndAddLink(network,l_id2, fromNode2,toNode2, CoordUtils.calcEuclideanDistance(fromNode1.getCoord(), toNode1.getCoord()),11,600,2);
        NetworkWriter writer = new NetworkWriter(network);
        writer.write(Paths.get("data", city_id, "original_input", "networks", network_id, "network.xml").toString());
        return network;

    }

}
