package si.ijs.urbanite.simserver.network;

import org.matsim.api.core.v01.Id;
import org.matsim.api.core.v01.Scenario;
import org.matsim.api.core.v01.network.Link;
import org.matsim.api.core.v01.network.Network;
import org.matsim.core.network.NetworkUtils;
import si.ijs.urbanite.simserver.district_closer.DistrictCloserParams;

import java.util.Map;

public class NetworkChangeEvent {

    //this only works for Bilbao
    public static void createNetworkChangeEventClose(int start_time, Network network, Scenario sc) {

        //start of closure
        org.matsim.core.network.NetworkChangeEvent networkChangeEventStart = new org.matsim.core.network.NetworkChangeEvent(start_time*60*60);
        networkChangeEventStart.setFreespeedChange(new org.matsim.core.network.NetworkChangeEvent.ChangeValue(org.matsim.core.network.NetworkChangeEvent.ChangeType.ABSOLUTE_IN_SI_UNITS, 0));
        networkChangeEventStart.setFlowCapacityChange(new org.matsim.core.network.NetworkChangeEvent.ChangeValue(org.matsim.core.network.NetworkChangeEvent.ChangeType.ABSOLUTE_IN_SI_UNITS, 0));


        for (Id<Link> l : network.getLinks().keySet()) {

            try {
                String name = network.getLinks().get(l).getId().toString();
                if (name.matches("(.*)_car_link(.*)")) {
                    System.out.println(l);
                    networkChangeEventStart.addLink(network.getLinks().get(l));
                }
            }
            catch (Exception e){

            }

        }

        NetworkUtils.addNetworkChangeEvent(sc.getNetwork(), networkChangeEventStart);

    }

    public static void createNetworkChangeEventOpen(int start_time, Network network, Scenario sc) {

        //start of closure
        org.matsim.core.network.NetworkChangeEvent networkChangeEventStart = new org.matsim.core.network.NetworkChangeEvent(start_time*60*60 );
        networkChangeEventStart.setFreespeedChange(new org.matsim.core.network.NetworkChangeEvent.ChangeValue(org.matsim.core.network.NetworkChangeEvent.ChangeType.ABSOLUTE_IN_SI_UNITS, 15));
        networkChangeEventStart.setFlowCapacityChange(new org.matsim.core.network.NetworkChangeEvent.ChangeValue(org.matsim.core.network.NetworkChangeEvent.ChangeType.ABSOLUTE_IN_SI_UNITS, 1200));


        for (Id<Link> l : network.getLinks().keySet()) {

            try {
                String name = network.getLinks().get(l).getId().toString();
                if (name.matches("(.*)_car_link(.*)")) {
                    System.out.println(l);
                    networkChangeEventStart.addLink(network.getLinks().get(l));
                }
            }
            catch (Exception e){

            }

        }

        NetworkUtils.addNetworkChangeEvent(sc.getNetwork(), networkChangeEventStart);

    }


    public static void createNetworkChangeEventCloseForEA(Network network, Scenario sc, DistrictCloserParams district_close_params) {

        //start of closure
        org.matsim.core.network.NetworkChangeEvent networkChangeEventStart = new org.matsim.core.network.NetworkChangeEvent(district_close_params.start);
        networkChangeEventStart.setFreespeedChange(new org.matsim.core.network.NetworkChangeEvent.ChangeValue(org.matsim.core.network.NetworkChangeEvent.ChangeType.ABSOLUTE_IN_SI_UNITS, 0));
        networkChangeEventStart.setFlowCapacityChange(new org.matsim.core.network.NetworkChangeEvent.ChangeValue(org.matsim.core.network.NetworkChangeEvent.ChangeType.ABSOLUTE_IN_SI_UNITS, 0));

        org.matsim.core.network.NetworkChangeEvent networkChangeEventEnd = null;

        Map<Id<Link>, ? extends Link> network_links = network.getLinks();

        for (Id<Link> l : district_close_params.links_to_be_closed) {
            networkChangeEventStart.addLink(network_links.get(l));

            //end of closure
            // TODO: test to see if getCapacity == getFlowCapacityPerSec
            networkChangeEventEnd = new org.matsim.core.network.NetworkChangeEvent(district_close_params.start+district_close_params.duration);
            networkChangeEventEnd.setFreespeedChange(new org.matsim.core.network.NetworkChangeEvent.ChangeValue(org.matsim.core.network.NetworkChangeEvent.ChangeType.ABSOLUTE_IN_SI_UNITS, network_links.get(l).getFreespeed()));
            networkChangeEventEnd.setFlowCapacityChange(new org.matsim.core.network.NetworkChangeEvent.ChangeValue(org.matsim.core.network.NetworkChangeEvent.ChangeType.ABSOLUTE_IN_SI_UNITS, network_links.get(l).getFlowCapacityPerSec()));

            NetworkUtils.addNetworkChangeEvent(sc.getNetwork(), networkChangeEventEnd);

        }
        NetworkUtils.addNetworkChangeEvent(sc.getNetwork(), networkChangeEventStart);

    }

}
