package si.ijs.urbanite.simserver.parameters;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.*;

import java.io.*;
import java.util.HashMap;
import java.util.Map;

@RestController()
@CrossOrigin
@RequestMapping("/traffic-simulation/parameters")
public class ParametersController {

    private final static Logger logger = LoggerFactory.getLogger(si.ijs.urbanite.simserver.simulation.SimulationController.class);
    private final static String ferriesToAddPath = "data/helsinki/before_simulation/ferries_to_add.csv";

    //This is just used to return a 200 OKAY status code, since returning just an int or a String makes the frontend think that we
    // returned a HttpErrorStatus
    private final static Map<String, Integer> okay_response = new HashMap<>();
    static {
        okay_response.put("response", 200);
    }

    public ParametersController() {}
    // Helsinki
    @PostMapping("/createFerry")
    public Map<String, Integer> postNewFerry(@RequestBody Map<String, Object> payload) throws IOException {
        int passenger_count = Integer.parseInt(payload.get("passenger_count").toString());
        int travel_time_seconds = Integer.parseInt(payload.get("travel_time").toString());
        String category = payload.get("category").toString();
        File ferries_from_user = new File(ferriesToAddPath);
        ferries_from_user.createNewFile(); // if already exists, does nothing
//        LineNumberReader lineReader = new LineNumberReader(new FileReader(ferriesPath));
//        lineReader.skip(Long.MAX_VALUE);
//        int sequence_nm = lineReader.getLineNumber() - 1;
        int sequence_nm = 0; // Just placeholder because we don't use this number in travel demand generation Helisnki
        String terminal = "West Terminal 2";
        String departsFrom = "IRRELEVANT_NOT_CALCULATED";
        String arrivesTo = "IRRELEVANT_NOT_CALCULATED";
        String[] row = {Integer.toString(sequence_nm), terminal, Integer.toString(travel_time_seconds), Integer.toString(passenger_count), departsFrom, arrivesTo, category};
        String newFerry = String.join(",", row) + "\n";
        FileWriter fw = new FileWriter(ferriesToAddPath,true);
        fw.write(newFerry);
        fw.close();
        return ParametersController.okay_response;
    }

    @GetMapping("/resetFerries")
    public Map<String, Integer> overwriteFerriesBackToOriginal() throws FileNotFoundException {
        PrintWriter writer = new PrintWriter(ferriesToAddPath);
        writer.print("");// just to clear the contents of the ferries_to_add.csv file, so previous ferry additions don't affect anything.
        writer.close();
        return ParametersController.okay_response;
    }

}
