package si.ijs.urbanite.simserver.plan;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import si.ijs.urbanite.simserver.entities.Plan;

@RestController()
@CrossOrigin
@RequestMapping("/traffic-simulation/plans")
public class PlanController {

    private final static Logger logger = LoggerFactory.getLogger(PlanController.class);
    private final PlanRepository planRepository;

    public PlanController(PlanRepository planRepository) {
        this.planRepository = planRepository;
    }


    @GetMapping("")
    public Iterable<Plan> getPlans() {
        return planRepository.findAll();
    }

}
