package si.ijs.urbanite.simserver.simulation;

import ch.sbb.matsim.routing.pt.raptor.SwissRailRaptorModule;
import org.matsim.api.core.v01.Id;
import org.matsim.api.core.v01.Scenario;
import org.matsim.api.core.v01.network.Link;
import org.matsim.core.config.Config;
import org.matsim.core.config.ConfigUtils;
import org.matsim.core.controler.Controler;
import org.matsim.core.controler.OutputDirectoryHierarchy;
import org.matsim.core.scenario.ScenarioUtils;
import org.matsim.vehicles.VehicleType;
import org.matsim.vehicles.VehicleUtils;
import si.ijs.urbanite.simserver.vehicles.VehiclesGeneration;

import java.nio.file.Paths;
import java.util.*;


public class RunSimulationAmstCyclists {

    public static void main(String[] args) {
        Config config = ConfigUtils.loadConfig(Paths.get("data","amsterdam","original_input","config.xml").toString());
//        Scenario sc = ScenarioUtils.loadScenario(config);
//
//
//        VehicleType bicycle_slow = VehicleUtils.getFactory().createVehicleType(Id.create("bicycle_slow", VehicleType.class));
//        bicycle_slow.setMaximumVelocity(5);
//        bicycle_slow.setNetworkMode("bicycle");
//        sc.getVehicles().addVehicleType(bicycle_slow);
//
//        VehicleType bicycle_medium = VehicleUtils.getFactory().createVehicleType(Id.create("bicycle_medium", VehicleType.class));
//        bicycle_medium.setMaximumVelocity(11);
//        bicycle_medium.setNetworkMode("bicycle");
//        sc.getVehicles().addVehicleType(bicycle_medium);
//
//        VehicleType bicycle_fast = VehicleUtils.getFactory().createVehicleType(Id.create("bicycle_fast", VehicleType.class));
//        bicycle_fast.setMaximumVelocity(18);
//        bicycle_fast.setNetworkMode("bicycle");
//        sc.getVehicles().addVehicleType(bicycle_fast);
//
//
//        Controler controler = new Controler(sc);
//        controler.getConfig().controler().setOverwriteFileSetting(OutputDirectoryHierarchy.OverwriteFileSetting.deleteDirectoryIfExists);
//        controler.getConfig().controler().setWriteEventsInterval(5);
//        controler.getConfig().controler().setLastIteration(5);
//
//        controler.getConfig().controler().setOutputDirectory(Paths.get("data","amsterdam","output").toString());
//
//        controler.getConfig().plans().setInputFile(Paths.get("data","amsterdam","original_input","plans.xml").toString());
//
//        controler.getConfig().qsim().setMainModes(Arrays.asList("car","bicycle_slow","bicycle_medium","bicycle_fast"));
//        controler.getConfig().subtourModeChoice().setModes(new String[]{"car","bicycle_slow","bicycle_medium","bicycle_fast"});
//        controler.getConfig().plansCalcRoute().setNetworkModes(Arrays.asList("car","bicycle_slow","bicycle_medium","bicycle_fast"));
//        Set<String> analyzedModes = new HashSet<>();
//        analyzedModes.add("car");
//        analyzedModes.add("bicycle_slow");
//        analyzedModes.add("bicycle_medium");
//        analyzedModes.add("bicycle_fast");
//        analyzedModes.add("walk");
//        controler.getConfig().travelTimeCalculator().setAnalyzedModes(analyzedModes);
//
//        for( Link link : sc.getNetwork().getLinks().values() ){
//            if (link.getAllowedModes().contains("bicycle")) {
//                // It would be better to set the modes directly in the input network file if not all car roads are open to rickshaw, cng, bus, hh etc.
//                Set allowedModes = new HashSet(link.getAllowedModes());
//                allowedModes.add("bicycle_slow");
//                allowedModes.add("bicycle_medium");
//                allowedModes.add("bicycle_fast");
//                link.setAllowedModes( allowedModes );
//            }
//        }

        Controler controler = VehiclesGeneration.addBicycleTypes(config);
        controler.getConfig().controler().setOverwriteFileSetting(OutputDirectoryHierarchy.OverwriteFileSetting.deleteDirectoryIfExists);
        controler.getConfig().controler().setWriteEventsInterval(50);
        controler.getConfig().controler().setLastIteration(2);

        controler.getConfig().controler().setOutputDirectory(Paths.get("data","amsterdam","simulations","1","results","output").toString());

        controler.addOverridingModule(new SwissRailRaptorModule());
        controler.run();
    }


}
