package si.ijs.urbanite.simserver.simulation;

import org.checkerframework.checker.units.qual.A;
import org.matsim.core.utils.collections.ArrayMap;

public class SimulationWithParamsDTO {
    public int simId;
    public int closure_start_time;
    public int closure_duration_time;
    //Bilbao districts
    public int percentage_population_change_ABANDO;
    public int percentage_population_change_BASURTO_ZORROTZA;
    public int percentage_population_change_BEGONA;
    public int percentage_population_change_DEUSTO;
    public int percentage_population_change_ERREKALDE;
    public int percentage_population_change_IBAIONDO;
    public int percentage_population_change_OTXARKOAGA_TXURDINAGA;
    public int percentage_population_change_URIBARRI;
    // Amsterdam districts
    public int percentage_population_change_Centrum_West_DX_01;
    public int percentage_population_change_Centrum_Oost_DX_02;
    public int percentage_population_change_Westerpark_DX_03;
    public int percentage_population_change_Bos_en_Lommer_DX_04;
    public int percentage_population_change_Oud_West_DX_05;
    public int percentage_population_change_DX_06;
    public int percentage_population_change_DX_07;
    public int percentage_population_change_DX_08;
    public int percentage_population_change_DX_09;
    public int percentage_population_change_DX_10;
    public int percentage_population_change_DX_11;
    public int percentage_population_change_DX_12;
    public int percentage_population_change_DX_13;
    public int percentage_population_change_DX_14;
    public int percentage_population_change_DX_15;
    public int percentage_population_change_DX_16;
    public int percentage_population_change_DX_17;
    public int percentage_population_change_DX_18;
    public int percentage_population_change_DX_19;
    public int percentage_population_change_DX_20;
    public int percentage_population_change_DX_21;
    public int percentage_population_change_DX_22;
    public int percentage_population_change_ZX_99;
    // Helsinki districts
    public int percentage_population_change_Etelainen;
    public int percentage_population_change_Lantinen;
    public int percentage_population_change_Keskinen;
    public int percentage_population_change_Pohjoinen;
    public int percentage_population_change_Koillinen;
    public int percentage_population_change_Kaakkoinen;
    public int percentage_population_change_Itainen;
    public int percentage_population_change_Ostersundom;
    // Messina districts
    public int percentage_population_change_1_Circoscrizione;
    public int percentage_population_change_2_Circoscrizione;
    public int percentage_population_change_3_Circoscrizione;
    public int percentage_population_change_4_Circoscrizione;
    public int percentage_population_change_5_Circoscrizione;
    public int percentage_population_change_6_Circoscrizione;


    @Override
    public String toString() {
        return "SimulationWithParamsDTO{" +
                "simId='" + simId + '\'' +
                ", closure_start_time='" + closure_start_time + '\'' +
                ", closure_duration_time=" + closure_duration_time +
                '}';
    }

    //bilbao districts
    public ArrayMap<String, Integer> bilbao_districts(){
        ArrayMap<String, Integer> all_bilbao_districts = new ArrayMap<>();
        all_bilbao_districts.put("BASURTU-ZORROTZA", percentage_population_change_BASURTO_ZORROTZA);
        all_bilbao_districts.put("BEGONA", percentage_population_change_BEGONA);
        all_bilbao_districts.put("DEUSTU", percentage_population_change_DEUSTO);
        all_bilbao_districts.put("ERREKALDE", percentage_population_change_ERREKALDE);
        all_bilbao_districts.put("IBAIONDO", percentage_population_change_IBAIONDO);
        all_bilbao_districts.put("OTXARKOAGA-TXURDINAGA", percentage_population_change_OTXARKOAGA_TXURDINAGA);
        all_bilbao_districts.put("URIBARRI", percentage_population_change_URIBARRI);
        all_bilbao_districts.put("ABANDO", percentage_population_change_ABANDO);
        return all_bilbao_districts;
    }
    public ArrayMap<String, Integer> bilbao_districts_index(){
        ArrayMap<String, Integer> all_bilbao_districts = new ArrayMap<>();
        all_bilbao_districts.put("BASURTU-ZORROTZA", 0);
        all_bilbao_districts.put("BEGONA", 1);
        all_bilbao_districts.put("DEUSTU", 2);
        all_bilbao_districts.put("ERREKALDE", 3);
        all_bilbao_districts.put("IBAIONDO", 4);
        all_bilbao_districts.put("OTXARKOAGA-TXURDINAGA", 5);
        all_bilbao_districts.put("URIBARRI", 6);
        all_bilbao_districts.put("ABANDO", 7);
        return all_bilbao_districts;
    }

    //amsterdam districts

    public ArrayMap<String, Integer> amsterdam_districts(){
        ArrayMap<String, Integer> all_amsterdam_districts = new ArrayMap<>();
        all_amsterdam_districts.put("DX01 Centrum-West",percentage_population_change_Centrum_West_DX_01);
        all_amsterdam_districts.put("DX02 Centrum-Oost",percentage_population_change_Centrum_Oost_DX_02);
        all_amsterdam_districts.put("DX03 Westerpark",percentage_population_change_Westerpark_DX_03);
        all_amsterdam_districts.put("DX04 Bos en Lommer",percentage_population_change_Bos_en_Lommer_DX_04);
        all_amsterdam_districts.put("DX05 Oud-West- De Baarsjes",percentage_population_change_Oud_West_DX_05);
        all_amsterdam_districts.put("DX06 Geuzenveld- Slotermeer- Sloterdijken",percentage_population_change_DX_06);
        all_amsterdam_districts.put("DX07 Osdorp",percentage_population_change_DX_07);
        all_amsterdam_districts.put("DX08 De Aker- Sloten- Nieuw-Sloten",percentage_population_change_DX_08);
        all_amsterdam_districts.put("DX09 Slotervaart",percentage_population_change_DX_09);
        all_amsterdam_districts.put("DX10 Oud-Zuid",percentage_population_change_DX_10);
        all_amsterdam_districts.put("DX11 Buitenveldert- Zuidas",percentage_population_change_DX_11);
        all_amsterdam_districts.put("DX12 De Pijp- Rivierenbuurt",percentage_population_change_DX_12);
        all_amsterdam_districts.put("DX13 Oud-Oost",percentage_population_change_DX_13);
        all_amsterdam_districts.put("DX14 Indische Buurt- Oostelijk Havengebied",percentage_population_change_DX_14);
        all_amsterdam_districts.put("DX15 Watergraafsmeer",percentage_population_change_DX_15);
        all_amsterdam_districts.put("DX16 IJburg- Zeeburgereiland",percentage_population_change_DX_16);
        all_amsterdam_districts.put("DX17 Noord-West",percentage_population_change_DX_17);
        all_amsterdam_districts.put("DX18 Oud-Noord",percentage_population_change_DX_18);
        all_amsterdam_districts.put("DX19 Noord-Oost",percentage_population_change_DX_19);
        all_amsterdam_districts.put("DX20 Bijlmer-Centrum- Amstel III",percentage_population_change_DX_20);
        all_amsterdam_districts.put("DX21 Bijlmer-Oost",percentage_population_change_DX_21);
        all_amsterdam_districts.put("DX22 Gaasperdam- Driemond",percentage_population_change_DX_22);
        all_amsterdam_districts.put("ZX99 Westpoort",percentage_population_change_ZX_99);
        return all_amsterdam_districts;
    }

    public ArrayMap<String, Integer> amsterdam_index(){
        ArrayMap<String, Integer> all_amsterdam_districts = new ArrayMap<>();
        all_amsterdam_districts.put("DX01 Centrum-West",0);
        all_amsterdam_districts.put("DX02 Centrum-Oost",1);
        all_amsterdam_districts.put("DX03 Westerpark",2);
        all_amsterdam_districts.put("DX04 Bos en Lommer",3);
        all_amsterdam_districts.put("DX05 Oud-West- De Baarsjes",4);
        all_amsterdam_districts.put("DX06 Geuzenveld- Slotermeer- Sloterdijken",5);
        all_amsterdam_districts.put("DX07 Osdorp",6);
        all_amsterdam_districts.put("DX08 De Aker- Sloten- Nieuw-Sloten",7);
        all_amsterdam_districts.put("DX09 Slotervaart",8);
        all_amsterdam_districts.put("DX10 Oud-Zuid",9);
        all_amsterdam_districts.put("DX11 Buitenveldert- Zuidas",10);
        all_amsterdam_districts.put("DX12 De Pijp- Rivierenbuurt",11);
        all_amsterdam_districts.put("DX13 Oud-Oost",12);
        all_amsterdam_districts.put("DX14 Indische Buurt- Oostelijk Havengebied",13);
        all_amsterdam_districts.put("DX15 Watergraafsmeer",14);
        all_amsterdam_districts.put("DX16 IJburg- Zeeburgereiland",15);
        all_amsterdam_districts.put("DX17 Noord-West",16);
        all_amsterdam_districts.put("DX18 Oud-Noord",17);
        all_amsterdam_districts.put("DX19 Noord-Oost",18);
        all_amsterdam_districts.put("DX20 Bijlmer-Centrum- Amstel III",19);
        all_amsterdam_districts.put("DX21 Bijlmer-Oost",20);
        all_amsterdam_districts.put("DX22 Gaasperdam- Driemond",21);
        all_amsterdam_districts.put("ZX99 Westpoort",22);
        return all_amsterdam_districts;
    }

    //helsinki districts
    public ArrayMap<String, Integer> helsinki_districts(){
        ArrayMap<String, Integer> all_helsinki_districts = new ArrayMap<>();
        all_helsinki_districts.put("Eteläinen", percentage_population_change_Etelainen);
        all_helsinki_districts.put("Läntinen", percentage_population_change_Lantinen);
        all_helsinki_districts.put("Keskinen", percentage_population_change_Keskinen);
        all_helsinki_districts.put("Pohjoinen", percentage_population_change_Pohjoinen);
        all_helsinki_districts.put("Koillinen", percentage_population_change_Koillinen);
        all_helsinki_districts.put("Kaakkoinen", percentage_population_change_Kaakkoinen);
        all_helsinki_districts.put("Itäinen", percentage_population_change_Itainen);
        all_helsinki_districts.put("Östersundom", percentage_population_change_Ostersundom);
        return all_helsinki_districts;
    }
    public ArrayMap<String, Integer> helsinki_districts_index(){
        ArrayMap<String, Integer> all_helsinki_districts = new ArrayMap<>();
        all_helsinki_districts.put("Eteläinen", 0);
        all_helsinki_districts.put("Läntinen", 1);
        all_helsinki_districts.put("Keskinen", 2);
        all_helsinki_districts.put("Pohjoinen", 3);
        all_helsinki_districts.put("Koillinen", 4);
        all_helsinki_districts.put("Kaakkoinen", 5);
        all_helsinki_districts.put("Itäinen", 6);
        all_helsinki_districts.put("Östersundom", 7);
        return all_helsinki_districts;
    }


    //messina districts
    public ArrayMap<String, Integer> messina_districts(){
        ArrayMap<String, Integer> all_messina_districts = new ArrayMap<>();
        all_messina_districts.put("1_Circoscrizione", percentage_population_change_1_Circoscrizione);
        all_messina_districts.put("2_Circoscrizione", percentage_population_change_2_Circoscrizione);
        all_messina_districts.put("3_Circoscrizione", percentage_population_change_3_Circoscrizione);
        all_messina_districts.put("4_Circoscrizione", percentage_population_change_4_Circoscrizione);
        all_messina_districts.put("5_Circoscrizione", percentage_population_change_5_Circoscrizione);
        all_messina_districts.put("6_Circoscrizione", percentage_population_change_6_Circoscrizione);
        return  all_messina_districts;
    }

    public ArrayMap<String, Integer> messina_districts_index(){
        ArrayMap<String, Integer> all_messina_districts = new ArrayMap<>();
        all_messina_districts.put("1_Circoscrizione", 0);
        all_messina_districts.put("2_Circoscrizione", 1);
        all_messina_districts.put("3_Circoscrizione", 2);
        all_messina_districts.put("4_Circoscrizione", 3);
        all_messina_districts.put("5_Circoscrizione", 4);
        all_messina_districts.put("6_Circoscrizione", 5);
        return  all_messina_districts;
    }
}
