To perform limited traffic zone (closing particular street for private cars only):

1. Removing cars from allowed modes in the link description caused simulation failure (network is not connected)
2. If network change event is used, all the vehicles including bus, cars, bicycles are not 
allowed in the closed area, or if they are already in that area, there is 
bus delay in amount of time equal to the time of closure since the buses are getting stuck in the closed area for that amount of time
3. Solution find in: https://github.com/matsim-org/matsim-code-examples/issues/629
   1. kainagel suggests to have multiple links between the same pair of nodes, e.g. one for bicycles and one for cars
   2. in our case separate layer for cars (marked with * _car_link * ) only was added on the Moyua square, while the existing one is modified for bicycles and tp only (mode="pt, bicycle")
   3. After testing, it showed that cars are headed on the car network layer, and pt&bicycles on the other network layer
   4. to close the square for cars, network change event for the car layer is performed 

-----------------------------------


Other tests to improve the stuck agents on the network:
------------------------------------------------------------



* Scenario 'Baseline':
    - Baseline network
    - Iterations: 10
* Results
  - output
  - 1053 cars entered
  - 3037 cyclists entered
  - 459 busses
------------------------------------------

* Scenario 'CloseMoyua1':
  - Two network layers (one for cars other for pt and cyclists)
  - Network change event (close car links from 00:00)
  - Parameters (stuckTime: 30)
  - Iterations: 10

* Results:
  - output1
  - 0 cars entered the car specific links
  - 0 cuyclists/buses enterd car specific links 
  - 3243 cyclists entered Moyua links
  - 443 busses entered Moyua links
  - 0 cars entered Moyua
  
* Analysis on stuck agents: