package si.ijs.urbanite.simserver.travel_demand;

import org.matsim.core.utils.collections.ArrayMap;
import si.ijs.urbanite.simserver.simulation.SimulationWithParamsDTO;

import java.io.*;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Random;

public class ChangeNumberInhabitants {
    public static void changeNumberInhabitants(String city, ArrayMap<String, Integer> district_param,  ArrayMap<String, Integer> district_param_index) throws IOException {

        ArrayMap<String, Integer> dist_totals = new ArrayMap<>();

        //read cons.csv
        String cons = Paths.get("data",city,"before_simulation","cons.csv").toString();
        BufferedReader br = new BufferedReader(new FileReader(cons));
        String line;
        Boolean header = true;
        while((line=br.readLine())!=null){
            if (!header) {
                String[] data = line.split(",");
                dist_totals.put(data[0], (int) Double.parseDouble(data[data.length - 1]));
            }
            header=false;
        }


        ArrayList<Integer> percantageChange = new ArrayList<>();
        for (String district : district_param.keySet()){
            Integer inhNumber = dist_totals.get(district)*district_param.get(district)/100;
            percantageChange.add(district_param_index.get(district),inhNumber);
        }

        //open ind_full.csv add persons to districts
        FileWriter fw = new FileWriter(Paths.get("data",city, "before_simulation","ind_full.csv").toString(), true);
        BufferedWriter bw = new BufferedWriter(fw);
        PrintWriter pw = new PrintWriter(bw);
        Random random = new Random();
        for (int i=0;i< percantageChange.size();i++){
//            System.out.println(percantageChange.get(i)+" "+i);
            for(int j=0;j<percantageChange.get(i);j++){
                //generate random f/m, age with district number i
                //add to ind_full.csv

                int age=0;
                String sex = "m";
                Boolean s = false;
                switch (city){
                    case "bilbao":{
                        age = random.nextInt(80)+10;
                        break;
                    }
                    case "amsterdam":{
                        age = random.nextInt(8)+1;
                        break;
                    }
                    case "messina":{
                        age = random.nextInt(4)+1;
                        break;
                    }
                    case "helsinki":{
                        age = random.nextInt(7)+1;
                        break;
                    }
                }
                s = random.nextBoolean();
                if (s){
                    sex = "f";
                }

                pw.println("new_"+j+","+age+","+sex+","+(i+1));
//                System.out.println("new_"+i+j+","+age+","+sex+","+(i+1));
            }
        }
        pw.close();
        bw.close();
        fw.close();

    }

    public static void main(String[] args) throws IOException {
        ArrayMap<String, Integer> all_bilbao_districts = new ArrayMap<>();
        all_bilbao_districts.put("BASURTU-ZORROTZA", 1);
        all_bilbao_districts.put("BEGONA", 10);
        all_bilbao_districts.put("DEUSTU", 1);
        all_bilbao_districts.put("ERREKALDE", 1);
        all_bilbao_districts.put("IBAIONDO", 1);
        all_bilbao_districts.put("OTXARKOAGA-TXURDINAGA", 0);
        all_bilbao_districts.put("URIBARRI", 0);
        all_bilbao_districts.put("ABANDO", 0);
        ArrayMap<String, Integer> district_param_index  = new ArrayMap<>();
        district_param_index.put("BASURTU-ZORROTZA", 0);
        district_param_index.put("BEGONA", 1);
        district_param_index.put("DEUSTU", 2);
        district_param_index.put("ERREKALDE", 3);
        district_param_index.put("IBAIONDO", 4);
        district_param_index.put("OTXARKOAGA-TXURDINAGA", 5);
        district_param_index.put("URIBARRI", 6);
        district_param_index.put("ABANDO", 7);
        changeNumberInhabitants("bilbao",all_bilbao_districts, district_param_index);
    }
}
