package si.ijs.urbanite.simserver.travel_demand;

import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import org.checkerframework.checker.units.qual.A;
import org.json.simple.JSONArray;
import org.json.simple.JSONObject;
import org.json.simple.parser.JSONParser;
import org.json.simple.parser.ParseException;
import org.matsim.core.utils.collections.ArrayMap;


public class Districts {
    //TODO add shape files to drive
    public static ArrayList<String> getBilbaoDistricts() {
//        DEUSTO = ['D1 NORTE','D1 SUR']
//        URIBARRI = ["CASTANOS","D2 ALTO","RIA ESTE","RIA OESTE","MB L3 (METRO BILBAO LINEA 3)"]
//        OTXARKOAGA_TXURDINAGA = ["OTXARKOAGA","TXURDINAGA"]
//        BEGONA = ["D4 SUR"]
//        IBAIONDO = ["CASCO VIEJO","D5 ESTE","D5 OESTE"]
//        ABANDO = ['CENTRO','HOSPITAL','ACCESOS V (ACCESOS VIARIOS)','INTERMODAL']
//        ERREKALDE = ["D7 NORTE","D7 SUR"]
//        BASURT_ZORROTZA = ["BASURTO","ZORROZA"]


        ArrayMap<String, ArrayList> districts = new ArrayMap<>();
        districts.put("Deusto", new ArrayList<>(Arrays.asList("Deusto", "D1 NORTE", "D1 SUR")));
        districts.put("Uribarri", new ArrayList<>(Arrays.asList("Uríbarri", "D2 ALTO", "RIA OESTE", "MB_L3")));
        districts.put("Otxarkoaga-Txurdinaga", new ArrayList<>(Arrays.asList("OTXARKOAGA", "TXURDINAGA")));
        districts.put("Begoña", new ArrayList<>(Arrays.asList("D4 SUR")));
        districts.put("Ibaiondo", new ArrayList<>(Arrays.asList("CASCO_VIEJO", "D5 OESTE")));
        districts.put("Abando", new ArrayList<>(Arrays.asList("CENTRO", "HOSPITAL", "ACCESOS_VIARIOS", "INTERMODAL")));
        districts.put("Recalde", new ArrayList<>(Arrays.asList("D7 NORTE", "D7 SUR")));
        districts.put("Basurto-Zorroza", new ArrayList<>(Arrays.asList("BASURTO", "ZORROZA")));


        ArrayList<String> districtsMain = new ArrayList<>(Arrays.asList("Deusto", "Uribarri", "Otxarkoaga-Txurdinaga", "Begoña", "Ibaiondo", "Abando", "Recalde", "Basurto-Zorroza"));


        return districtsMain;

    }

    public static ArrayMap<String,Polygon> readShapeFile() throws IOException, ParseException {


        ArrayList<String> districts = getBilbaoDistricts();
        ArrayMap<String, Polygon> district_polygon = new ArrayMap<>();

        String path = Paths.get("data", "bilbao", "before_simulation", "shapes.json").toString();

        JSONParser parser = new JSONParser();
        FileReader reader = new FileReader(path);
        Object obj = parser.parse(reader);
        JSONArray a = (JSONArray) obj;


        for (Object district : a) {
            JSONObject dist = (JSONObject) district;
            String name = (String) dist.get("description");
            if (districts.contains(name)) {
                List<Point> vertices = new ArrayList<>();
                JSONObject n = (JSONObject) dist.get("location");
                JSONArray coord = (JSONArray) n.get("coordinates");
                for (int i=0;i<coord.size();i++){
                    ArrayList c = (ArrayList) coord.get(i);
                    vertices.add(new Point((Double) c.get(0),(Double)c.get(1)));
                }
                Polygon polygon = new Polygon(vertices);
                district_polygon.put(name,polygon);
            }
        }
        return district_polygon;
    }

    public static void readFacilityFile(){

        String path = Paths.get("data","bilbao","before_simulation","other.geojson").toString();

    }

    public static void main(String[] args) throws IOException, ParseException {

    }
}
