package si.ijs.urbanite.simserver.travel_demand;


import java.util.List;

public class Polygon {
    private final List<Point> vertices;

    public Polygon(List<Point> vertices) {
        this.vertices = vertices;
    }

    public boolean contains(Point point) {
        int crossings = 0;

        for (int i = 0; i < vertices.size(); i++) {
            Point vertex1 = vertices.get(i);
            Point vertex2 = vertices.get((i + 1) % vertices.size());

            if (vertex1.y <= point.y && vertex2.y > point.y ||
                    vertex2.y <= point.y && vertex1.y > point.y) {
                double dx = vertex2.x - vertex1.x;
                double dy = vertex2.y - vertex1.y;
                double x = vertex1.x + (point.y - vertex1.y) / dy * dx;

                if (x < point.x) {
                    crossings++;
                }
            }
        }

        return crossings % 2 != 0;
    }
}
