package si.ijs.urbanite.simserver.utils;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

import java.util.HashMap;

public class EventHandler extends DefaultHandler {

    public static HashMap<Integer, Integer> map = new HashMap<Integer, Integer>();

    @Override
    public void startElement(String uri,
                             String localName,
                             String qName,
                             Attributes attributes) throws SAXException {

        if (qName.equalsIgnoreCase("event")) {
            String link = attributes.getValue("link");
            String type = attributes.getValue("type");
            String vehicle = attributes.getValue("vehicle");
            if (type.equals("entered link")) {

                //System.out.println("Link: " + link + ", type:" + type + ", vehicle:" + vehicle);
                if(Character.isDigit(link.charAt(0))){
                    //System.out.println("Link: " + link + ", type:" + type + ", vehicle:" + vehicle);
                    int number = Integer.parseInt(link);

                    if(!map.containsKey(number)){
                        map.put(number, 1);
                    }
                    else{
                        map.put(number, map.get(number) + 1);
                    }
                }
                else if(link.charAt(0) == 'p' && link.length() < 9){

                    //System.out.println("Link: " + link + ", type:" + type + ", vehicle:" + vehicle);
                    String subLink = link.substring(3, link.length());
                    int integerLink = Integer.parseInt(subLink);

                    if(!map.containsKey(integerLink)){
                        map.put(integerLink, 1);
                    }
                    else{
                        map.put(integerLink, map.get(integerLink) + 1);
                    }
                }
            }
        }

    }
}

