package si.ijs.urbanite.simserver.utils;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

import java.util.ArrayList;
import java.util.HashMap;

public class NetworkHandler extends DefaultHandler {
    public static HashMap<String, ArrayList<String>> linksNetwork= new HashMap<String, ArrayList<String>>();
    public static HashMap<String, ArrayList<Double>> coordinatesNetwork= new HashMap<String, ArrayList<Double>>();

    @Override
    public void startElement(String uri, String localName, String qName, Attributes attributes) throws SAXException {

        if (qName.equalsIgnoreCase("link")) {
            String id = attributes.getValue("id");
            if(!id.startsWith("pt")) {
                String from = attributes.getValue("from");
                String to = attributes.getValue("to");
                //System.out.println("Id: " + id + ", from:" + from + ", to:" + to);

                ArrayList<String> coordinates = new ArrayList<String>();
                coordinates.add(from);
                coordinates.add(to);
                linksNetwork.put(id, coordinates);
            }

        }

        if (qName.equalsIgnoreCase("node")) {
            String id = attributes.getValue("id");
            String x = attributes.getValue("x");
            String y = attributes.getValue("y");
            //System.out.println("Id: " + id + ", x:" + x + ", y:" + y);
            if(id.charAt(0) == 'p'){
                id = id.substring(3, id.length());
                //System.out.println(id);
            }
            ArrayList<Double> coordinates = new ArrayList<Double>();
            coordinates.add(Double.parseDouble(x));
            coordinates.add(Double.parseDouble(y));
            coordinatesNetwork.put(id, coordinates);

        }

    }

}
