package si.ijs.urbanite.simserver.utils;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

public class SaxParser {

    public static void parseNetworkXML(File networkFile) {
        try {
            SAXParserFactory factory = SAXParserFactory.newInstance();
            SAXParser saxParser = factory.newSAXParser();
            StreetsHandler streetsHandler = new StreetsHandler();
            saxParser.parse(networkFile, streetsHandler);
            System.out.println("network file parsed");
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void parseXML(File file) {
        try {
            SAXParserFactory factory = SAXParserFactory.newInstance();
            SAXParser saxParser = factory.newSAXParser();

            if (file.getPath().contains("emission")) {
                if (file.getPath().contains("amsterdam") || file.getPath().contains("bilbaoTime")) {
                    AmsterdamHandler amsterdamHandler = new AmsterdamHandler();
                    saxParser.parse(file, amsterdamHandler);
                }
            } else if (file.getPath().contains("events")) {
                EventHandler demoHandler = new EventHandler();
                saxParser.parse(file, demoHandler);
            } else if (file.getPath().contains("network")) {
                NetworkHandler eventHandler = new NetworkHandler();
                saxParser.parse(file, eventHandler);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
